#Step 0 - Insert Components from File
#Version 1.0

#Inserts components from the users SketchUp Components Library into the drawing
#Component definitions must be saved in the folowing directory:  C:\Users\(userid)\Documents\Sketchup\Custom Components\
#.csv file format (no headers required):  Instance Name, Definition Name, X Location, Y Location, Z Location
#ensure that the .cvs file location units match the desired SketchUp drawing units (typically inches)

require 'sketchup.rb'

module Insert_components_from_file
 
  def Insert_components_from_file.main


	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
	mod.start_operation "Insert Components from File"
	
	file_path = ENV["USERPROFILE"] + '\Desktop\.csv'
	file_name = UI.openpanel("Select file",file_path)

	lines = IO.readlines(file_name)

	lines.each{|line|
  
		data = line.split(",")
  
		comp_fullname = data[1] + '.skp'
		comp_path = ENV["USERPROFILE"] + "\\Documents\\Sketchup\\Custom Components\\" + comp_fullname
		comp_def = Sketchup.active_model.definitions.load comp_path
  
		location = [data[2].to_f, data[3].to_f, data[4].to_f]
		translation = Geom::Transformation.new location
		instance = ent.add_instance comp_def, translation
		instance.name = data[0]

	} #end of each

   text = "#{lines.length} components added"
   UI.messagebox(text, MB_OK)

   mod.commit_operation

	end # .main method
 
end # Insert_components_from_file module

#----------------menu------------------
if !file_loaded?(__FILE__)
  UI.menu("Plugins").add_item("Step 0 - Insert Components from File") { Insert_components_from_file.main }
end
 
file_loaded(__FILE__)
